public class Rectangle {

	private int width;
	private int height;

	//No-arg Constructor (which is called when we do "new Rectangle()"
	public Rectangle() {
		//Constructing a Rectangle: 0 by 0
		this.width = 0;
		this.height = 0;
	}

	public Rectangle(int aWidth, int aHeight) {
		//Constructing a Rectangle: aWidth by aHeight
		this.width = aWidth;
		this.height = aHeight;
	}

	public Rectangle(int aDimension) {
		//Constructing a Square: aDimension by aDimension
		//A square is  special type of rectangle
		this.width = aDimension;
		this.height = aDimension;
	}

	//------------------------------------------
	//Getters

	public int getWidth() {
		return this.width;
	}

	public int getHeight() {
		return this.height;
	}
	
	//------------------------------------------
	//Setters

	public void setWidth(int aWidth) {
		width = aWidth;
	}

	public void setHeight(int aHeight) {
		height = aHeight;
	}
	
	//------------------------------------------
	//Derived Values
	
	public int getArea() {
		return this.getWidth() * this.getHeight();
	}
	
	public int getPerimeter() {
		return 2 * (this.getWidth() + this.getHeight());
	}	
	
	public int getDiagonal() {
		int
			w = this.getWidth(),
			h = this.getHeight();
		return (int)Math.round(Math.sqrt(w*w + h*h));
	}
	
	public String getSummary() {
		String summary = "";
		String sep = System.lineSeparator();
		summary += "Width: " + this.getWidth() + sep;		
		summary += "Height: " + this.getHeight() + sep;
		summary += "Area: " + this.getArea() + sep;
		summary += "Perimeter: " + this.getPerimeter() + sep;
		summary += "Diagonal: " + this.getDiagonal() + sep;		
		return summary;
	}		

	//------------------------------------------
	//Common

	public String toString() {
		//Return a "nice" display string
		return "" + width + " x " + height;
	}

	//------------------------------------------

	public void setDimensions(int aWidth, int aHeight) {
		width = aWidth;
		height = aHeight;
	}

	public void growBy(int amount) {
		width = width + amount;
		height = height + amount;
	}

	public void growBy(int widthAmount, int heightAmount) {
		width = width + widthAmount;
		height = height + heightAmount;
	}

}