import java.awt.Cursor;

import javax.swing.JButton;

public class RectangleController extends Controller {

	//---------------------------------------------------
	//Ivars	

	private Rectangle model;
	private View view;

	//---------------------------------------------------
	//Constructors	

	public RectangleController(Rectangle aModel, View aView) {
		super();
		this.model = aModel;
		this.view = aView;
	}

	//---------------------------------------------------
	//Getters

	public Rectangle getModel() {
		return model;
	}

	//---------------------------------------------------
	//Hooking Up Events	

	protected void hookUpEvents() {
		((JButton) this.get("calculateButton")).addActionListener(evt -> this.clickedGo());
	}

	//---------------------------------------------------
	//Framework Methods
	
	@Override
	/** apply the view values to the model */
	public void apply() {
		this.getModel().setWidth(getFieldValueAsInteger("widthField"));		
		this.getModel().setHeight(getFieldValueAsInteger("heightField"));		
	}	

	@Override
	/** refresh the view from the model */	
	public void refresh() {
		setFieldValue("widthField", this.getModel().getWidth());		
		setFieldValue("heightField", this.getModel().getHeight());		
		setFieldValue("areaField", this.getModel().getArea());
		setFieldValue("perimeterField", this.getModel().getPerimeter());
		setFieldValue("diagonalField", this.getModel().getDiagonal());		
		setMultiLineFieldValue("summaryField", this.getModel().getSummary());
	}

	@Override
	public View getView() {
		return this.view;
	}

	//---------------------------------------------------
	//Action Handlers

	public void clickedGo() {
		//JOptionPane.showMessageDialog(null, "Hello!", "Title", JOptionPane.INFORMATION_MESSAGE);
		try {
			this.view.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
			this.apply();
			this.refresh();
		} finally {
			this.view.setCursor(Cursor.getDefaultCursor());
		}

	}

}