import java.awt.Dimension;

import javax.swing.JButton;
import javax.swing.JPanel;

@SuppressWarnings("serial")

public class RectangleView extends View {
	
	//---------------------------------------------------
	//Ivars	
	
	private RectangleController controller;
	
	//---------------------------------------------------
	//Constructors	

	RectangleView() {
		//The next line calls the one-arg constructor
		//this("MVC Example");
		super("Rectangle View");
		controller = new RectangleController(new Rectangle(), this);		
		
	    JPanel outer = createVertGroup();

		outer.add(this.createFieldGroup());		
		
		//Action Buttons
		JPanel buttonBar = createButtonGroup();
		outer.add(buttonBar);		
				
		this.add(outer);
		this.setBounds(900, 500, 400, 500);
		this.setVisible(true);
		
		this.controller.hookUpEvents();
		this.controller.refresh();		
	}
	
	//---------------------------------------------------
	//Building View Groups
	
	private JPanel createFieldGroup() {
		//Fields	
		JPanel fields = createVertGroup();
		fields.add(createField(this, "widthField", "Width", true));
		fields.add(createField(this, "heightField", "Height", true));		
		fields.add(createField(this, "areaField", "Area", false));
		fields.add(createField(this, "perimeterField", "Perimeter", false));
		fields.add(createField(this, "diagonalField", "Diagonal", false));
		fields.add(createMultiLineField(this, "summaryField", "Summary", false,
				new Dimension(200, 200)));
		return fields;
	}
	
	private JPanel createButtonGroup() {
		JPanel buttons = createHorizGroup();
		JButton button = new JButton("Calculate");
		button.setName("calculateButton");
		buttons.add(button);
		return buttons;
	}	
	
	//---------------------------------------------------
	//Main (Program Launch Point / Entry Point)	
	
	public static void main(String args[]) {
		new RectangleView();
	}
}